<?php
/////////////////////////////////////////////////////////////////////////////////
//	CMail.php	- 
//
//
// Copyright (c) 1999-2003   Easynara 
//
// Permission to use for commercial purposes only, is hereby granted with fee, 
// providing that the above copyright notice appear in all copies and 
// that both the copyright notice and this permission notice appear 
// in supporting documentation.
//
// This software is provided "as is" without any expressed or implied warranty.
//////////////////////////////////////////////////////////////////////////////////
// ۱ (c) 1999-2002  
//
//  α׷ ҽ () ǿ 
//  Ƿ  ǿ  뵵θ   ֽϴ. 
//  ۱ ȳ ϵ  Ҽҿ װ 纻 
// ۱ǿ  ڼ  help@easynara.co.kr Ͻʽÿ.
/////////////////////////////////////////////////////////////////////////////////

class CMail
{
    var $host;
    var $fp;
    var $self;
    var $lastmsg;
    var $parts;
    var $error;
    var $debug;
    var $charset;
    var $ctype;

    function CMail( $host = "localhost" ) 
	{
        if( $host == "self" ) 
			$this->self = true;
        else 
			$this->host = $host;

		$this->parts = array();
        $this->error = array();
        $$this->debug = 0;
        $this->charset = "euc-kr";
        $this->ctype = "text/html";
    }

    function _dialogue( $code, $cmd ) 
	{
        fputs( $this->fp, $cmd."\r\n" );
        $line = fgets( $this->fp, 1024 );
        ereg( "^([0-9]+).(.*)$", $line, &$data );
        $this->lastmsg = $data[0];

        if( $this->debug ) 
		{
            echo htmlspecialchars( $cmd )."<br>".$this->lastmsg."<br>";
            flush();
        }
		else
			echo " ";

        if( $data[1] != $code )
			return false;

        return true;
    }

    function _connectSmtp( $host ) 
	{
        if( $this->debug ) 
		{
            echo "SMTP($host) Connecting...<br>";
            flush();
        }
		else
			echo " ";

        if( !$host ) 
			$host = $this->host;

        if( !$this->fp = fsockopen( $host, 25, $errno, $errstr, 10 ) ) 
		{
            $this->lastmsg = "SMTP($host) ӿ ߽ϴ.[$errno:$errstr]";
            return false;
        }

        $line = fgets( $this->fp, 1024 );
        ereg( "^([0-9]+).(.*)$", $line, &$data );
        $this->lastmsg = $data[0];
        
		if( $data[1] != "220" ) 
			return false;

        if( $this->debug ) 
		{
            echo $this->lastmsg."<br>";
            flush();
        }
		else
			echo " ";

        $this->_dialogue( 250, "HELO phpmail" );
        return true;

    }

    function _closeSmtp() 
	{
        $this->_dialogue( 221, "QUIT" );
        fclose( $this->fp );
        return true;
    }

    function _sendSmtp( $email, $from, $data ) 
	{
        if( !$mail_from = $this->_getEmail( $from ) ) 
			return false;

        if( !$rcpt_to = $this->_getEmail( $email ) ) 
			return false;

        if( !$this->_dialogue( 250, "MAIL FROM:$mail_from" ) ) 
            $this->error[] = $email.":MAIL FROM ($this->lastmsg)";

        if( !$this->_dialogue( 250, "RCPT TO:$rcpt_to" ) )
            $this->error[] = $email.":RCPT TO ($this->lastmsg)";
        
		$this->_dialogue( 354, "DATA" );

        $mime = "Message-ID: <".$this->_getMessageID().">\r\n";
        $mime .= "From: $from\r\n";
        $mime .= "To: $email\r\n";

        fputs( $this->fp, $mime );
        fputs( $this->fp, $data );
        $this->_dialogue( 250, "." );
    }

	function _getMessageID() 
	{
		$id = date( "YmdHis",time() );
		mt_srand( (float) microtime() * 1000000 );
		$randval = mt_rand();
		$id .= $randval."@bluemail";
		return $id;
	}

	function _getBoundary() 
	{
		$uniqchr = uniqid( time() );
		$one = strtoupper( $uniqchr[0] );
		$two = strtoupper( substr( $uniqchr,0,8 ) );
		$three = strtoupper(substr(strrev( $uniqchr ),0,8 ) );
		return "----=_NextPart_000_000${one}_${two}.${three}";
	}

    function _buildMessage( $part ) 
	{
        $msg .= "Content-Type: ".$part['ctype'];
        if( $part['name'] ) 
			$msg .= "; name=\"".$part['name']."\"";

        $msg .= "\r\nContent-Transfer-Encoding: base64\r\n";
        $msg .= "Content-Disposition: attachment; filename=\"".$part['name']."\"\r\n\r\n";
        $msg .= chunk_split( base64_encode( $part['message'] ) );
        return $msg;
    }

    function _buildData( $subject, $body ) 
	{
        $boundary = $this->_getBoundary();
        $mime .= "Subject: $subject\r\n";
        $mime .= "Date: ".date ("D, j M Y H:i:s T",time())."\r\n";
        $mime .= "MIME-Version: 1.0\r\n";
        $mime .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\r\n\r\n".
                 "This is a multi-part message in MIME format.\r\n\r\n";
		$mime .= "--".$boundary."\r\n".
             "Content-Type: ".$this->ctype."; charset=\"".$this->charset."\"\r\n".
             "Content-Transfer-Encoding: base64\r\n\r\n".
             chunk_split(base64_encode($body)).
             "\r\n\r\n--".$boundary;

        $max = count($this->parts);

        for($i=0; $i<$max; $i++) 
            $mime .= "\r\n".$this->_buildMessage( $this->parts[$i] )."\r\n\r\n--".$boundary;

        $mime .= "--\r\n";

        return $mime;
    }

    function _getMXServer( $email ) 
	{
		if( !ereg( "([\._0-9a-zA-Z-]+)@([0-9a-zA-Z-]+\.[a-zA-Z\.]+)", $email, $reg ) ) 
			return false;

        getmxrr( $reg[2], $host );

        if( !$host ) 
			$host[0] = $reg[2];

        return $host;
    }

    function _getEmail( $email ) 
	{
        if( !ereg("([\._0-9a-zA-Z-]+)@([0-9a-zA-Z-]+\.[a-zA-Z\.]+)", $email, $reg ) ) 
			return false;

        return "<".$reg[0].">";
    }

    function debug( $n = 1 ) 
	{
        $this->debug = $n;
    }

    function attach( $path, $name="", $ctype="application/octet-stream" ) 
	{ 
		$fp = fopen( $path, "r" ); 
		$message = fread( $fp, filesize( $path ) ); 
		fclose( $fp ); 
		$this->parts[] = array ("ctype" => $ctype, "message" => $message, "name" => $name); 
	} 

    function send( $to, $from, $subject, $body ) 
	{
		if( !is_array( $to ) ) 
			$to = split("[,;]",$to); 

        if( $this->self ) 
		{
            $data = $this->_buildData( $subject, $body );

            foreach( $to as $email ) 
			{
                if( $host = $this->_getMXServer( $email ) ) 
				{
                    $flag = false; $i = 0;

                    while( $flag == false ) 
					{
                        if( $host[$i] ) 
						{
                            $flag = $this->_connectSmtp( $host[$i] );
                            $i++;
                        } 
						else 
							break;
                    }

                    if( $flag ) 
					{
                        $this->_sendSmtp( $email, $from, $data );
                        $this->_closeSmtp();
                    } 
					else 
                        $this->error[] = $email.":SMTP ӽ";
                } 
				else 
                    $this->error[] = $email.": ߸";
            }

        } 
		else 
		{
            if( !$this->_connectSmtp( $this->host ) ) 
			{
                $this->error[] = "$this->host SMTP ӽ";
                return false;
            }

            $data = $this->_buildData( $subject, $body );

            foreach( $to as $email ) 
				$this->_sendSmtp( $email, $from, $data );

            $this->_closeSmtp();
        }
    }
}
?> 